Loading...
Searching...
No Matches
juce::AlertWindow Class Reference

## Detailed Description

A window that displays a message and has buttons for the user to react to it.

For simple dialog boxes with just a couple of buttons on them, there are some static methods for running these.

For more complex dialogs, an AlertWindow can be created, then it can have some buttons and components added to it, and its enterModalState() method is used to show it. The value returned to the ModalComponentManager::Callback shows which button the user pressed to dismiss the box.

See also
  ThreadWithProgressWindow, Component::enterModalState

The documentation for this class was generated from the following file:

- juce_gui_basics/windows/juce_AlertWindow.h

Inheritance diagram for juce::AlertWindow:

## Classes

struct | LookAndFeelMethods
| This abstract base class is implemented by LookAndFeel classes to provide alert-window drawing functionality. More...

## Public Types

enum | ColourIds { backgroundColourId = 0x1001800 , textColourId = 0x1001810 , outlineColourId = 0x1001820 }
| A set of colour IDs to use to change the colour of various aspects of the alert box. More...
using | AlertIconType = MessageBoxIconType
Public Types inherited from juce::Component
enum class | WindowControlKind { client , caption , minimise , maximise , close , sizeTop , sizeLeft , sizeRight , sizeBottom , sizeTopLeft , sizeTopRight , sizeBottomLeft , sizeBottomRight }
| Types of control that are commonly found in windows, especially title-bars. More...
enum class | FocusContainerType { none , focusContainer , keyboardFocusContainer }
| A focus container type that can be passed to setFocusContainerType(). More...
enum | FocusChangeType { focusChangedByMouseClick , focusChangedByTabKey , focusChangedDirectly }
| Enumeration used by the focusGained() and focusLost() methods. More...
enum class | FocusChangeDirection { unknown , forward , backward }
| Enumeration used by the focusGainedWithDirection() method. More...

## Public Member Functions

| AlertWindow (const String &title, const String &message, MessageBoxIconType iconType, Component *associatedComponent=nullptr)
| Creates an AlertWindow.
| ~AlertWindow () override
| Destroys the AlertWindow.
MessageBoxIconType | getAlertType () const noexcept
| Returns the type of alert icon that was specified when the window was created.
void | setMessage (const String &message)
| Changes the dialog box's message.
void | addButton (const String &name, int returnValue, const KeyPress &shortcutKey1=KeyPress(), const KeyPress &shortcutKey2=KeyPress())
| Adds a button to the window.
int | getNumButtons () const
| Returns the number of buttons that the window currently has.
Button * | getButton (int index) const
| Returns a Button that was added to the AlertWindow.
Button * | getButton (const String &buttonName) const
| Returns a Button that was added to the AlertWindow.
void | triggerButtonClick (const String &buttonName)
| Invokes a click of one of the buttons.
void | setEscapeKeyCancels (bool shouldEscapeKeyCancel)
| If set to true and the window contains no buttons, then pressing the escape key will make the alert cancel its modal state.
void | addTextEditor (const String &name, const String &initialContents, const String &onScreenLabel=String(), bool isPasswordBox=false)
| Adds a textbox to the window for entering strings.
String | getTextEditorContents (const String &nameOfTextEditor) const
| Returns the contents of a named textbox.
TextEditor * | getTextEditor (const String &nameOfTextEditor) const
| Returns a pointer to a textbox that was added with addTextEditor().
void | addComboBox (const String &name, const StringArray &items, const String &onScreenLabel=String())
| Adds a drop-down list of choices to the box.
ComboBox * | getComboBoxComponent (const String &nameOfList) const
| Returns a drop-down list that was added to the AlertWindow.
void | addTextBlock (const String &text)
| Adds a block of text.
void | addProgressBarComponent (double &progressValue, std::optional< ProgressBar::Style > style=std::nullopt)
| Adds a progress-bar to the window.
void | addCustomComponent (Component *component)
| Adds a user-defined component to the dialog box.
int | getNumCustomComponents () const
| Returns the number of custom components in the dialog box.
Component * | getCustomComponent (int index) const
| Returns one of the custom components in the dialog box.
Component * | removeCustomComponent (int index)
| Removes one of the custom components in the dialog box.
bool | containsAnyExtraComponents () const
| Returns true if the window contains any components other than just buttons.
std::unique_ptr< AccessibilityHandler > | createAccessibilityHandler () override
| Override this method to return a custom AccessibilityHandler for this component.
Public Member Functions inherited from juce::TopLevelWindow
| TopLevelWindow (const String &name, bool addToDesktop)
| Creates a TopLevelWindow.
| ~TopLevelWindow () override
| Destructor.
bool | isActiveWindow () const noexcept
| True if this is currently the TopLevelWindow that is actively being used.
void | centreAroundComponent (Component *componentToCentreAround, int width, int height)
| This will set the bounds of the window so that it's centred in front of another window.
void | setDropShadowEnabled (bool useShadow)
| Turns the drop-shadow on and off.
bool | isDropShadowEnabled () const noexcept
| True if drop-shadowing is enabled.
void | setUsingNativeTitleBar (bool useNativeTitleBar)
| Sets whether an OS-native title bar will be used, or a JUCE one.
bool | isUsingNativeTitleBar () const noexcept
| Returns true if the window is currently using an OS-native title bar.
void | addToDesktop ()
| Adds the window to the desktop using the default flags.
void | addToDesktop (int windowStyleFlags, void *nativeWindowToAttachTo=nullptr) override
| Makes this component appear as a window on the desktop.
std::unique_ptr< AccessibilityHandler > | createAccessibilityHandler () override
| Override this method to return a custom AccessibilityHandler for this component.
Public Member Functions inherited from juce::Component
| Component () noexcept
| Creates a component.
| ~Component () override
| Destructor.
| Component (const String &componentName) noexcept
| Creates a component, setting its name at the same time.
String | getName () const noexcept
| Returns the name of this component.
virtual void | setName (const String &newName)
| Sets the name of this component.
String | getComponentID () const noexcept
| Returns the ID string that was set by setComponentID().
void | setComponentID (const String &newID)
| Sets the component's ID string.
virtual void | setVisible (bool shouldBeVisible)
| Makes the component visible or invisible.
bool | isVisible () const noexcept
| Tests whether the component is visible or not.
bool | isShowing () const
| Tests whether this component and all its parents are visible.
void | removeFromDesktop ()
| If the component is currently showing on the desktop, this will hide it.
bool | isOnDesktop () const noexcept
| Returns true if this component is currently showing on the desktop.
ComponentPeer * | getPeer () const
| Returns the heavyweight window that contains this component.
virtual void | minimisationStateChanged (bool isNowMinimised)
| Called for a desktop component which has just been minimised or un-minimised.
void | toFront (bool shouldAlsoGainKeyboardFocus)
| Brings the component to the front of its siblings.
void | toBack ()
| Changes this component's z-order to be at the back of all its siblings.
void | toBehind (Component *other)
| Changes this component's z-order so that it's just behind another component.
void | setAlwaysOnTop (bool shouldStayOnTop)
| Sets whether the component should always be kept at the front of its siblings.
bool | isAlwaysOnTop () const noexcept
| Returns true if this component is set to always stay in front of its siblings.
int | getX () const noexcept
| Returns the x coordinate of the component's left edge.
int | getY () const noexcept
| Returns the y coordinate of the top of this component.
int | getWidth () const noexcept
| Returns the component's width in pixels.
int | getHeight () const noexcept
| Returns the component's height in pixels.
int | getRight () const noexcept
| Returns the x coordinate of the component's right-hand edge.
Point< int > | getPosition () const noexcept
| Returns the component's top-left position as a Point.
int | getBottom () const noexcept
| Returns the y coordinate of the bottom edge of this component.
Rectangle< int > | getBounds () const noexcept
| Returns this component's bounding box.
Rectangle< int > | getLocalBounds () const noexcept
| Returns the component's bounds, relative to its own origin.
Rectangle< int > | getBoundsInParent () const noexcept
| Returns the area of this component's parent which this component covers.
int | getScreenX () const
| Returns this component's x coordinate relative the screen's top-left origin.
int | getScreenY () const
| Returns this component's y coordinate relative the screen's top-left origin.
Point< int > | getScreenPosition () const
| Returns the position of this component's top-left corner relative to the screen's top-left.
Rectangle< int > | getScreenBounds () const
| Returns the bounds of this component, relative to the screen's top-left.
Point< int > | getLocalPoint (const Component *sourceComponent, Point< int > pointRelativeToSourceComponent) const
| Converts a point to be relative to this component's coordinate space.
Point< float > | getLocalPoint (const Component *sourceComponent, Point< float > pointRelativeToSourceComponent) const
| Converts a point to be relative to this component's coordinate space.
Rectangle< int > | getLocalArea (const Component *sourceComponent, Rectangle< int > areaRelativeToSourceComponent) const
| Converts a rectangle to be relative to this component's coordinate space.
Rectangle< float > | getLocalArea (const Component *sourceComponent, Rectangle< float > areaRelativeToSourceComponent) const
| Converts a rectangle to be relative to this component's coordinate space.
Point< int > | localPointToGlobal (Point< int > localPoint) const
| Converts a point relative to this component's top-left into a screen coordinate.
Point< float > | localPointToGlobal (Point< float > localPoint) const
| Converts a point relative to this component's top-left into a screen coordinate.
Rectangle< int > | localAreaToGlobal (Rectangle< int > localArea) const
| Converts a rectangle from this component's coordinate space to a screen coordinate.
Rectangle< float > | localAreaToGlobal (Rectangle< float > localArea) const
| Converts a rectangle from this component's coordinate space to a screen coordinate.
void | setTopLeftPosition (int x, int y)
| Moves the component to a new position.
void | setTopLeftPosition (Point< int > newTopLeftPosition)
| Moves the component to a new position.
void | setTopRightPosition (int x, int y)
| Moves the component to a new position.
void | setTopRightPosition (Point< int >)
| Moves the component to a new position.
void | setSize (int newWidth, int newHeight)
| Changes the size of the component.
void | setBounds (int x, int y, int width, int height)
| Changes the component's position and size.
void | setBounds (Rectangle< int > newBounds)
| Changes the component's position and size.
void | setBoundsRelative (float proportionalX, float proportionalY, float proportionalWidth, float proportionalHeight)
| Changes the component's position and size in terms of fractions of its parent's size.
void | setBoundsRelative (Rectangle< float > proportionalArea)
| Changes the component's position and size in terms of fractions of its parent's size.
void | setBoundsInset (BorderSize< int > borders)
| Changes the component's position and size based on the amount of space to leave around it.
void | setBoundsToFit (Rectangle< int > targetArea, Justification justification, bool onlyReduceInSize)
| Positions the component within a given rectangle, keeping its proportions unchanged.
void | setCentrePosition (int x, int y)
| Changes the position of the component's centre.
void | setCentrePosition (Point< int > newCentrePosition)
| Changes the position of the component's centre.
void | setCentreRelative (float x, float y)
| Changes the position of the component's centre.
void | centreWithSize (int width, int height)
| Changes the component's size and centres it within its parent.
void | setTransform (const AffineTransform &transform)
| Sets a transform matrix to be applied to this component.
AffineTransform | getTransform () const
| Returns the transform that is currently being applied to this component.
bool | isTransformed () const noexcept
| Returns true if a non-identity transform is being applied to this component.
int | proportionOfWidth (float proportion) const noexcept
| Returns a proportion of the component's width.
int | proportionOfHeight (float proportion) const noexcept
| Returns a proportion of the component's height.
int | getParentWidth () const noexcept
| Returns the width of the component's parent.
int | getParentHeight () const noexcept
| Returns the height of the component's parent.
Rectangle< int > | getParentMonitorArea () const
| Returns the screen coordinates of the monitor that contains this component.
int | getNumChildComponents () const noexcept
| Returns the number of child components that this component contains.
Component * | getChildComponent (int index) const noexcept
| Returns one of this component's child components, by it index.
int | getIndexOfChildComponent (const Component *child) const noexcept
| Returns the index of this component in the list of child components.
const Array< Component * > & | getChildren () const noexcept
| Provides access to the underlying array of child components.
Component * | findChildWithID (StringRef componentID) const noexcept
| Looks for a child component with the specified ID.
void | addChildComponent (Component *child, int zOrder=-1)
| Adds a child component to this one.
void | addChildComponent (Component &child, int zOrder=-1)
| Adds a child component to this one.
void | addAndMakeVisible (Component *child, int zOrder=-1)
| Adds a child component to this one, and also makes the child visible if it isn't already.
void | addAndMakeVisible (Component &child, int zOrder=-1)
| Adds a child component to this one, and also makes the child visible if it isn't already.
void | addChildAndSetID (Component *child, const String &componentID)
| Adds a child component to this one, makes it visible, and sets its component ID.
void | removeChildComponent (Component *childToRemove)
| Removes one of this component's child-components.
Component * | removeChildComponent (int childIndexToRemove)
| Removes one of this component's child-components by index.
void | removeAllChildren ()
| Removes all this component's children.
void | deleteAllChildren ()
| Removes and deletes all of this component's children.
Component * | getParentComponent () const noexcept
| Returns the component which this component is inside.
template<class TargetClass>
TargetClass * | findParentComponentOfClass () const
| Searches the parent components for a component of a specified class.
Component * | getTopLevelComponent () const noexcept
| Returns the highest-level component which contains this one or its parents.
bool | isParentOf (const Component *possibleChild) const noexcept
| Checks whether a component is anywhere inside this component or its children.
virtual void | childrenChanged ()
| Subclasses can use this callback to be told when children are added or removed, or when their z-order changes.
virtual bool | hitTest (int x, int y)
| Tests whether a given point is inside the component.
virtual WindowControlKind | findControlAtPoint (Point< float >) const
| For components that are added to the desktop, this may be called to determine what kind of control is at particular locations in the window.
virtual void | windowControlClickedClose ()
| For components that are added to the desktop, this may be called to indicate that the mouse was clicked inside the area of the "close" control.
virtual void | windowControlClickedMinimise ()
| For components that are added to the desktop, this may be called to indicate that the mouse was clicked inside the area of the "minimise" control.
virtual void | windowControlClickedMaximise ()
| For components that are added to the desktop, this may be called to indicate that the mouse was clicked inside the area of the "maximise" control.
void | setInterceptsMouseClicks (bool allowClicksOnThisComponent, bool allowClicksOnChildComponents) noexcept
| Changes the default return value for the hitTest() method.
void | getInterceptsMouseClicks (bool &allowsClicksOnThisComponent, bool &allowsClicksOnChildComponents) const noexcept
| Retrieves the current state of the mouse-click interception flags.
bool | contains (Point< int > localPoint)
| Returns true if a given point lies within this component or one of its children.
bool | contains (Point< float > localPoint)
| Returns true if a given point lies within this component or one of its children.
bool | reallyContains (Point< int > localPoint, bool returnTrueIfWithinAChild)
| Returns true if a given point lies in this component, taking any overlapping siblings into account.
bool | reallyContains (Point< float > localPoint, bool returnTrueIfWithinAChild)
| Returns true if a given point lies in this component, taking any overlapping siblings into account.
Component * | getComponentAt (int x, int y)
| Returns the component at a certain point within this one.
Component * | getComponentAt (Point< int > position)
| Returns the component at a certain point within this one.
Component * | getComponentAt (Point< float > position)
| Returns the component at a certain point within this one.
void | repaint ()
| Marks the whole component as needing to be redrawn.
void | repaint (int x, int y, int width, int height)
| Marks a subsection of this component as needing to be redrawn.
void | repaint (Rectangle< int > area)
| Marks a subsection of this component as needing to be redrawn.
void | setBufferedToImage (bool shouldBeBuffered)
| Makes the component use an internal buffer to optimise its redrawing.
Image | createComponentSnapshot (Rectangle< int > areaToGrab, bool clipImageToComponentBounds=true, float scaleFactor=1.0f, const ImageType &imageType=NativeImageType{})
| Generates a snapshot of part of this component.
void | paintEntireComponent (Graphics &context, bool ignoreAlphaLevel)
| Draws this component and all its subcomponents onto the specified graphics context.
void | setPaintingIsUnclipped (bool shouldPaintWithoutClipping) noexcept
| This allows you to indicate that this component doesn't require its graphics context to be clipped when it is being painted.
bool | isPaintingUnclipped () const noexcept
| Returns true if this component doesn't require its graphics context to be clipped when it is being painted.
void | setComponentEffect (ImageEffectFilter *newEffect)
| Adds an effect filter to alter the component's appearance.
ImageEffectFilter * | getComponentEffect () const noexcept
| Returns the current component effect.
LookAndFeel & | getLookAndFeel () const noexcept
| Finds the appropriate look-and-feel to use for this component.
void | setLookAndFeel (LookAndFeel *newLookAndFeel)
| Sets the look and feel to use for this component.
FontOptions | withDefaultMetrics (FontOptions opt) const
| Returns a copy of the FontOptions with the default metrics kind from the component's LookAndFeel.
void | sendLookAndFeelChange ()
| Calls the methods repaint(), lookAndFeelChanged(), and colourChanged() in this component and all its children recursively.
void | setOpaque (bool shouldBeOpaque)
| Indicates whether any parts of the component might be transparent.
bool | isOpaque () const noexcept
| Returns true if no parts of this component are transparent.
void | setBroughtToFrontOnMouseClick (bool shouldBeBroughtToFront) noexcept
| Indicates whether the component should be brought to the front when clicked.
bool | isBroughtToFrontOnMouseClick () const noexcept
| Indicates whether the component should be brought to the front when clicked-on.
void | setExplicitFocusOrder (int newFocusOrderIndex)
| Sets the focus order of this component.
int | getExplicitFocusOrder () const
| Returns the focus order of this component, if one has been specified.
void | setFocusContainerType (FocusContainerType containerType) noexcept
| Sets whether this component is a container for components that can have their focus traversed, and the type of focus traversal that it supports.
bool | isFocusContainer () const noexcept
| Returns true if this component has been marked as a focus container.
bool | isKeyboardFocusContainer () const noexcept
| Returns true if this component has been marked as a keyboard focus container.
Component * | findFocusContainer () const
| Returns the focus container for this component.
Component * | findKeyboardFocusContainer () const
| Returns the keyboard focus container for this component.
void | setWantsKeyboardFocus (bool wantsFocus) noexcept
| Sets a flag to indicate whether this component wants keyboard focus or not.
bool | getWantsKeyboardFocus () const noexcept
| Returns true if the component is interested in getting keyboard focus.
void | setMouseClickGrabsKeyboardFocus (bool shouldGrabFocus)
| Chooses whether a click on this component automatically grabs the focus.
bool | getMouseClickGrabsKeyboardFocus () const noexcept
| Returns the last value set with setMouseClickGrabsKeyboardFocus().
void | grabKeyboardFocus ()
| Tries to give keyboard focus to this component.
void | giveAwayKeyboardFocus ()
| If this component or any of its children currently have the keyboard focus, this will defocus it, send a focus change notification, and try to pass the focus to the next component.
bool | hasKeyboardFocus (bool trueIfChildIsFocused) const
| Returns true if this component currently has the keyboard focus.
void | moveKeyboardFocusToSibling (bool moveToNext)
| Tries to move the keyboard focus to one of this component's siblings.
virtual std::unique_ptr< ComponentTraverser > | createFocusTraverser ()
| Creates a ComponentTraverser object to determine the logic by which focus should be passed from this component.
virtual std::unique_ptr< ComponentTraverser > | createKeyboardFocusTraverser ()
| Creates a ComponentTraverser object to use to determine the logic by which keyboard focus should be passed from this component.
void | setHasFocusOutline (bool hasFocusOutline) noexcept
| Use this to indicate that the component should have an outline drawn around it when it has keyboard focus.
bool | hasFocusOutline () const noexcept
| Returns true if this component should have a focus outline.
bool | isEnabled () const noexcept
| Returns true if the component (and all its parents) are enabled.
void | setEnabled (bool shouldBeEnabled)
| Enables or disables this component.
virtual void | enablementChanged ()
| Callback to indicate that this component has been enabled or disabled.
float | getAlpha () const noexcept
| Returns the component's current transparency level.
void | setAlpha (float newAlpha)
| Changes the transparency of this component.
virtual void | alphaChanged ()
| Called when setAlpha() is used to change the alpha value of this component.
void | setMouseCursor (const MouseCursor &cursorType)
| Changes the mouse cursor shape to use when the mouse is over this component.
virtual MouseCursor | getMouseCursor ()
| Returns the mouse cursor shape to use when the mouse is over this component.
void | updateMouseCursor () const
| Forces the current mouse cursor to be updated.
virtual void | paintOverChildren (Graphics &g)
| Components can override this method to draw over the top of their children.
void | mouseMove (const MouseEvent &event) override
| Called when the mouse moves inside a component.
void | mouseEnter (const MouseEvent &event) override
| Called when the mouse first enters a component.
void | mouseExit (const MouseEvent &event) override
| Called when the mouse moves out of a component.
void | mouseDown (const MouseEvent &event) override
| Called when a mouse button is pressed.
void | mouseDrag (const MouseEvent &event) override
| Called when the mouse is moved while a button is held down.
void | mouseUp (const MouseEvent &event) override
| Called when a mouse button is released.
void | mouseDoubleClick (const MouseEvent &event) override
| Called when a mouse button has been double-clicked on a component.
void | mouseWheelMove (const MouseEvent &event, const MouseWheelDetails &wheel) override
| Called when the mouse-wheel is moved.
void | mouseMagnify (const MouseEvent &event, float scaleFactor) override
| Called when a pinch-to-zoom mouse-gesture is used.
void | setRepaintsOnMouseActivity (bool shouldRepaint) noexcept
| Causes automatic repaints when the mouse enters or exits this component.
void | addMouseListener (MouseListener *newListener, bool wantsEventsForAllNestedChildComponents)
| Registers a listener to be told when mouse events occur in this component.
void | removeMouseListener (MouseListener *listenerToRemove)
| Deregisters a mouse listener.
void | addKeyListener (KeyListener *newListener)
| Adds a listener that wants to hear about keypresses that this component receives.
void | removeKeyListener (KeyListener *listenerToRemove)
| Removes a previously-registered key listener.
virtual bool | keyStateChanged (bool isKeyDown)
| Called when a key is pressed or released.
virtual void | modifierKeysChanged (const ModifierKeys &modifiers)
| Called when a modifier key is pressed or released.
virtual void | focusGained (FocusChangeType cause)
| Called to indicate that this component has just acquired the keyboard focus.
virtual void | focusGainedWithDirection (FocusChangeType cause, FocusChangeDirection direction)
| Called to indicate that this component has just acquired the keyboard focus.
virtual void | focusLost (FocusChangeType cause)
| Called to indicate that this component has just lost the keyboard focus.
bool | isMouseOver (bool includeChildren=false) const
| Returns true if the mouse is currently over this component.
bool | isMouseButtonDown (bool includeChildren=false) const
| Returns true if the mouse button is currently held down in this component.
bool | isMouseOverOrDragging (bool includeChildren=false) const
| True if the mouse is over this component, or if it's being dragged in this component.
Point< int > | getMouseXYRelative () const
| Returns the mouse's current position, relative to this component.
virtual void | resized ()
| Called when this component's size has been changed.
virtual void | moved ()
| Called when this component's position has been changed.
virtual void | childBoundsChanged (Component *child)
| Called when one of this component's children is moved or resized.
virtual void | parentSizeChanged ()
| Called when this component's immediate parent has been resized.
virtual void | broughtToFront ()
| Called when this component has been moved to the front of its siblings.
void | addComponentListener (ComponentListener *newListener)
| Adds a listener to be told about changes to the component hierarchy or position.
void | removeComponentListener (ComponentListener *listenerToRemove)
| Removes a component listener.
void | postCommandMessage (int commandId)
| Dispatches a numbered message to this component.
virtual void | handleCommandMessage (int commandId)
| Called to handle a command that was sent by postCommandMessage().
int | runModalLoop ()
| Runs a component modally, waiting until the loop terminates.
void | enterModalState (bool takeKeyboardFocus=true, ModalComponentManager::Callback *callback=nullptr, bool deleteWhenDismissed=false)
| Puts the component into a modal state.
void | exitModalState (int returnValue=0)
| Ends a component's modal state.
bool | isCurrentlyModal (bool onlyConsiderForemostModalComponent=true) const noexcept
| Returns true if this component is the modal one.
bool | isCurrentlyBlockedByAnotherModalComponent () const
| Checks whether there's a modal component somewhere that's stopping this one from receiving messages.
virtual bool | canModalEventBeSentToComponent (const Component *targetComponent)
| When a component is modal, this callback allows it to choose which other components can still receive events.
virtual void | inputAttemptWhenModal ()
| Called when the user tries to click on a component that is blocked by another modal component.
NamedValueSet & | getProperties () noexcept
| Returns the set of properties that belong to this component.
const NamedValueSet & | getProperties () const noexcept
| Returns the set of properties that belong to this component.
Colour | findColour (int colourID, bool inheritFromParent=false) const
| Looks for a colour that has been registered with the given colour ID number.
void | setColour (int colourID, Colour newColour)
| Registers a colour to be used for a particular purpose.
void | removeColour (int colourID)
| If a colour has been set with setColour(), this will remove it.
bool | isColourSpecified (int colourID) const
| Returns true if the specified colour ID has been explicitly set for this component using the setColour() method.
void | copyAllExplicitColoursTo (Component &target) const
| This looks for any colours that have been specified for this component, and copies them to the specified target component.
virtual void | colourChanged ()
| This method is called when a colour is changed by the setColour() method, or when the look-and-feel is changed by the setLookAndFeel() or sendLookAndFeelChange() methods.
void * | getWindowHandle () const
| Returns the underlying native window handle for this component.
Positioner * | getPositioner () const noexcept
| Returns the Positioner object that has been set for this component.
void | setPositioner (Positioner *newPositioner)
| Sets a new Positioner object for this component.
void | setCachedComponentImage (CachedComponentImage *newCachedImage)
| Gives the component a CachedComponentImage that should be used to buffer its painting.
CachedComponentImage * | getCachedComponentImage () const noexcept
| Returns the object that was set by setCachedComponentImage().
void | invalidateCachedImageResources ()
| Invalidates cached images, both in the CachedComponentImage (if any) and the image effect state.
void | setViewportIgnoreDragFlag (bool ignoreDrag) noexcept
| Sets a flag to indicate whether mouse drag events on this Component should be ignored when it is inside a Viewport with drag-to-scroll functionality enabled.
bool | getViewportIgnoreDragFlag () const noexcept
| Retrieves the current state of the Viewport drag-to-scroll functionality flag.
String | getTitle () const noexcept
| Returns the title text for this component.
void | setTitle (const String &newTitle)
| Sets the title for this component.
String | getDescription () const noexcept
| Returns the description for this component.
void | setDescription (const String &newDescription)
| Sets the description for this component.
String | getHelpText () const noexcept
| Returns the help text for this component.
void | setHelpText (const String &newHelpText)
| Sets the help text for this component.
void | setAccessible (bool shouldBeAccessible)
| Sets whether this component and its children are visible to accessibility clients.
bool | isAccessible () const noexcept
| Returns true if this component and its children are visible to accessibility clients.
AccessibilityHandler * | getAccessibilityHandler ()
| Returns the accessibility handler for this component, or nullptr if this component is not accessible.
void | invalidateAccessibilityHandler ()
| Invalidates the AccessibilityHandler that is currently being used for this component.
Public Member Functions inherited from juce::MouseListener
virtual | ~MouseListener ()=default
| Destructor.

## Static Public Member Functions

static void JUCE_CALLTYPE | showMessageBox (MessageBoxIconType iconType, const String &title, const String &message, const String &buttonText=String(), Component *associatedComponent=nullptr)
| Shows a dialog box that just has a message and a single button to get rid of it.
static int JUCE_CALLTYPE | show (const MessageBoxOptions &options)
| Shows a dialog box using the specified options.
static void JUCE_CALLTYPE | showAsync (const MessageBoxOptions &options, ModalComponentManager::Callback *callback)
| Shows a dialog box using the specified options.
static void JUCE_CALLTYPE | showAsync (const MessageBoxOptions &options, std::function< void(int)> callback)
| Shows a dialog box using the specified options.
static void JUCE_CALLTYPE | showMessageBoxAsync (MessageBoxIconType iconType, const String &title, const String &message, const String &buttonText=String(), Component *associatedComponent=nullptr, ModalComponentManager::Callback *callback=nullptr)
| Shows a dialog box that just has a message and a single button to get rid of it.
static bool JUCE_CALLTYPE | showOkCancelBox (MessageBoxIconType iconType, const String &title, const String &message, const String &button1Text=String(), const String &button2Text=String(), Component *associatedComponent=nullptr, ModalComponentManager::Callback *callback=nullptr)
| Shows a dialog box with two buttons.
static int JUCE_CALLTYPE | showYesNoCancelBox (MessageBoxIconType iconType, const String &title, const String &message, const String &button1Text=String(), const String &button2Text=String(), const String &button3Text=String(), Component *associatedComponent=nullptr, ModalComponentManager::Callback *callback=nullptr)
| Shows a dialog box with three buttons.
static ScopedMessageBox | showScopedAsync (const MessageBoxOptions &options, std::function< void(int)> callback)
| Shows an alert window using the specified options.
Static Public Member Functions inherited from juce::TopLevelWindow
static int | getNumTopLevelWindows () noexcept
| Returns the number of TopLevelWindow objects currently in use.
static TopLevelWindow * | getTopLevelWindow (int index) noexcept
| Returns one of the TopLevelWindow objects currently in use.
static TopLevelWindow * | getActiveTopLevelWindow () noexcept
| Returns the currently-active top level window.
Static Public Member Functions inherited from juce::Component
static float JUCE_CALLTYPE | getApproximateScaleFactorForComponent (const Component *targetComponent)
| Returns the approximate scale factor for a given component by traversing its parent hierarchy and applying each transform and finally scaling this by the global scale factor.
static Component *JUCE_CALLTYPE | getCurrentlyFocusedComponent () noexcept
| Returns the component that currently has the keyboard focus.
static void JUCE_CALLTYPE | unfocusAllComponents ()
| If any component has keyboard focus, this will defocus it.
static void JUCE_CALLTYPE | beginDragAutoRepeat (int millisecondsBetweenCallbacks)
| Ensures that a non-stop stream of mouse-drag events will be sent during the current mouse-drag operation.
static bool JUCE_CALLTYPE | isMouseButtonDownAnywhere () noexcept
| Returns true if a mouse button is currently down.
static int JUCE_CALLTYPE | getNumCurrentlyModalComponents () noexcept
| Returns the number of components that are currently in a modal state.
static Component *JUCE_CALLTYPE | getCurrentlyModalComponent (int index=0) noexcept
| Returns one of the components that are currently modal.

## Static Public Attributes

static constexpr auto | NoIcon = MessageBoxIconType::NoIcon
static constexpr auto | QuestionIcon = MessageBoxIconType::QuestionIcon
static constexpr auto | WarningIcon = MessageBoxIconType::WarningIcon
static constexpr auto | InfoIcon = MessageBoxIconType::InfoIcon

## Protected Member Functions

void | paint (Graphics &) override
| Components can override this method to draw their content.
void | mouseDown (const MouseEvent &) override
| Called when a mouse button is pressed.
void | mouseDrag (const MouseEvent &) override
| Called when the mouse is moved while a button is held down.
bool | keyPressed (const KeyPress &) override
| Called when a key is pressed.
void | lookAndFeelChanged () override
| Called to let the component react to a change in the look-and-feel setting.
void | userTriedToCloseWindow () override
| For components on the desktop, this is called if the system wants to close the window.
int | getDesktopWindowStyleFlags () const override
float | getDesktopScaleFactor () const override
| Returns the default scale factor to use for this component when it is placed on the desktop.
Protected Member Functions inherited from juce::TopLevelWindow
virtual void | activeWindowStatusChanged ()
| This callback happens when this window becomes active or inactive.
void | focusOfChildComponentChanged (FocusChangeType) override
| Called to indicate a change in whether or not this component is the parent of the currently-focused component.
void | parentHierarchyChanged () override
| Called to indicate that the component's parents have changed.
void | recreateDesktopWindow ()
void | visibilityChanged () override
| Called when this component's visibility changes.

## Member Typedef Documentation

## AlertIconType

using juce::AlertWindow::AlertIconType = MessageBoxIconType

## Member Enums

## ColourIds

enum juce::AlertWindow::ColourIds

A set of colour IDs to use to change the colour of various aspects of the alert box.

These constants can be used either via the Component::setColour(), or LookAndFeel::setColour() methods.

See also
  Component::setColour, Component::findColour, LookAndFeel::setColour, LookAndFeel::findColour

Enumerator
backgroundColourId | The background colour for the window.
textColourId | The colour for the text.
outlineColourId | An optional colour to use to draw a border around the window.

## Constructors and Destructors

## AlertWindow()

juce::AlertWindow::AlertWindow | ( | const String & | title,
|  | const String & | message,
|  | MessageBoxIconType | iconType,
|  | Component * | associatedComponent = nullptr )

Creates an AlertWindow.

Parameters

  title | the headline to show at the top of the dialog box
  message | a longer, more descriptive message to show underneath the headline
  iconType | the type of icon to display
  associatedComponent | if this is non-null, it specifies the component that the alert window should be associated with. Depending on the look and feel, this might be used for positioning of the alert window.

Referenced by juce::AlertWindow::LookAndFeelMethods::createAlertWindow(), juce::AlertWindow::LookAndFeelMethods::drawAlertBox(), and juce::AlertWindow::LookAndFeelMethods::getWidthsForTextButtons().

## ~AlertWindow()

juce::AlertWindow::~AlertWindow | ( |  | ) |

override

Destroys the AlertWindow.

## Member Functions

## getAlertType()

MessageBoxIconType juce::AlertWindow::getAlertType | ( |  | ) | const

inline noexcept

Returns the type of alert icon that was specified when the window was created.

## setMessage()

void juce::AlertWindow::setMessage | ( | const String & | message | ) |

Changes the dialog box's message.

This will also resize the window to fit the new message if required.

## addButton()

void juce::AlertWindow::addButton | ( | const String & | name,
|  | int | returnValue,
|  | const KeyPress & | shortcutKey1 = KeyPress(),
|  | const KeyPress & | shortcutKey2 = KeyPress() )

Adds a button to the window.

Parameters

  name | the text to show on the button
  returnValue | the value that should be returned from runModalLoop() if this is the button that the user presses.
  shortcutKey1 | an optional key that can be pressed to trigger this button
  shortcutKey2 | a second optional key that can be pressed to trigger this button

References name.

## getNumButtons()

int juce::AlertWindow::getNumButtons | ( |  | ) | const

Returns the number of buttons that the window currently has.

## getButton() [1/2]

Button * juce::AlertWindow::getButton | ( | int | index | ) | const

Returns a Button that was added to the AlertWindow.

Parameters

  index | the index of the button in order that it was added with the addButton() method.

Returns
  the Button component, or nullptr if the index is out of bounds.

See also
  getNumButtons

## getButton() [2/2]

Button * juce::AlertWindow::getButton | ( | const String & | buttonName | ) | const

Returns a Button that was added to the AlertWindow.

Parameters

  buttonName | the name that was passed into the addButton() method

Returns
  the Button component, or nullptr if none was found for the given name.

## triggerButtonClick()

void juce::AlertWindow::triggerButtonClick | ( | const String & | buttonName | ) |

Invokes a click of one of the buttons.

## setEscapeKeyCancels()

void juce::AlertWindow::setEscapeKeyCancels | ( | bool | shouldEscapeKeyCancel | ) |

If set to true and the window contains no buttons, then pressing the escape key will make the alert cancel its modal state.

By default this setting is true - turn it off if you don't want the box to respond to the escape key. Note that it is ignored if you have any buttons, and in that case you should give the buttons appropriate keypresses to trigger cancelling if you want to.

## addTextEditor()

void juce::AlertWindow::addTextEditor | ( | const String & | name,
|  | const String & | initialContents,
|  | const String & | onScreenLabel = String(),
|  | bool | isPasswordBox = false )

Adds a textbox to the window for entering strings.

Parameters

  name | an internal name for the text-box. This is the name to pass to the getTextEditorContents() method to find out what the user typed-in.
  initialContents | a string to show in the text box when it's first shown
  onScreenLabel | if this is non-empty, it will be displayed next to the text-box to label it.
  isPasswordBox | if true, the text editor will display asterisks instead of the actual text

See also
  getTextEditorContents

References name.

## getTextEditorContents()

String juce::AlertWindow::getTextEditorContents | ( | const String & | nameOfTextEditor | ) | const

Returns the contents of a named textbox.

After showing an AlertWindow that contains a text editor, this can be used to find out what the user has typed into it.

Parameters

  nameOfTextEditor | the name of the text box that you're interested in

See also
  addTextEditor

## getTextEditor()

TextEditor * juce::AlertWindow::getTextEditor | ( | const String & | nameOfTextEditor | ) | const

Returns a pointer to a textbox that was added with addTextEditor().

## addComboBox()

void juce::AlertWindow::addComboBox | ( | const String & | name,
|  | const StringArray & | items,
|  | const String & | onScreenLabel = String() )

Adds a drop-down list of choices to the box.

After the box has been shown, the getComboBoxComponent() method can be used to find out which item the user picked.

Parameters

  name | the label to use for the drop-down list
  items | the list of items to show in it
  onScreenLabel | if this is non-empty, it will be displayed next to the combo-box to label it.

See also
  getComboBoxComponent

References name.

## getComboBoxComponent()

ComboBox * juce::AlertWindow::getComboBoxComponent | ( | const String & | nameOfList | ) | const

Returns a drop-down list that was added to the AlertWindow.

Parameters

  nameOfList | the name that was passed into the addComboBox() method when creating the drop-down

Returns
  the ComboBox component, or nullptr if none was found for the given name.

## addTextBlock()

void juce::AlertWindow::addTextBlock | ( | const String & | text | ) |

Adds a block of text.

This is handy for adding a multi-line note next to a textbox or combo-box, to provide more details about what's going on.

## addProgressBarComponent()

void juce::AlertWindow::addProgressBarComponent | ( | double & | progressValue,
|  | std::optional< ProgressBar::Style > | style = std::nullopt )

Adds a progress-bar to the window.

Parameters

  progressValue | a variable that will be repeatedly checked while the dialog box is visible, to see how far the process has got. The value should be in the range 0 to 1.0
  style | determines the style the ProgressBar should adopt. By default this use a style automatically chosen by the LookAndFeel, but you can force a particular style by passing a non-optional value.

See also
  ProgressBar::setStyle

## addCustomComponent()

void juce::AlertWindow::addCustomComponent | ( | Component * | component | ) |

Adds a user-defined component to the dialog box.

Parameters

  component | the component to add - its size should be set up correctly before it is passed in. The caller is responsible for deleting the component later on - the AlertWindow won't delete it.

## getNumCustomComponents()

int juce::AlertWindow::getNumCustomComponents | ( |  | ) | const

Returns the number of custom components in the dialog box.

See also
  getCustomComponent, addCustomComponent

## getCustomComponent()

Component * juce::AlertWindow::getCustomComponent | ( | int | index | ) | const

Returns one of the custom components in the dialog box.

Parameters

  index | a value 0 to (getNumCustomComponents() - 1). Out-of-range indexes will return nullptr

See also
  getNumCustomComponents, addCustomComponent

## removeCustomComponent()

Component * juce::AlertWindow::removeCustomComponent | ( | int | index | ) |

Removes one of the custom components in the dialog box.

Note that this won't delete it, it just removes the component from the window

Parameters

  index | a value 0 to (getNumCustomComponents() - 1). Out-of-range indexes will return nullptr

Returns
  the component that was removed (or null)

See also
  getNumCustomComponents, addCustomComponent

## containsAnyExtraComponents()

bool juce::AlertWindow::containsAnyExtraComponents | ( |  | ) | const

Returns true if the window contains any components other than just buttons.

## showMessageBox()

void JUCE_CALLTYPE juce::AlertWindow::showMessageBox | ( | MessageBoxIconType | iconType,
|  | const String & | title,
|  | const String & | message,
|  | const String & | buttonText = String(),
|  | Component * | associatedComponent = nullptr )

static

Shows a dialog box that just has a message and a single button to get rid of it.

The box is shown modally, and the method will block until the user has clicked the button (or pressed the escape or return keys).

Parameters

  iconType | the type of icon to show
  title | the headline to show at the top of the box
  message | a longer, more descriptive message to show underneath the headline
  buttonText | the text to show in the button - if this string is empty, the default string "OK" (or a localised version) will be used.
  associatedComponent | if this is non-null, it specifies the component that the alert window should be associated with. Depending on the look and feel, this might be used for positioning of the alert window.

References JUCE_CALLTYPE.

## show()

int JUCE_CALLTYPE juce::AlertWindow::show | ( | const MessageBoxOptions & | options | ) |

static

Shows a dialog box using the specified options.

The box is shown modally, and the method will block until the user dismisses it.

Parameters

  options | the options to use when creating the dialog.

Returns
  the following result codes:
  - One button:
    - button[0] returns 0
  - Two buttons:
    - button[0] returns 1
    - button[1] returns 0
  - Three buttons:
    - button[0] returns 1
    - button[1] returns 2
    - button[2] returns 0

Another way of expressing this is that, when there are N buttons, then the result code for button X is equal to ((X + 1) % N).

See also
  MessageBoxOptions

References JUCE_CALLTYPE.

## showAsync() [1/2]

void JUCE_CALLTYPE juce::AlertWindow::showAsync | ( | const MessageBoxOptions & | options,
|  | ModalComponentManager::Callback * | callback )

static

Shows a dialog box using the specified options.

The box will be displayed and placed into a modal state, but this method will return immediately, and the callback will be invoked later when the user dismisses the box.

Parameters

  options | the options to use when creating the dialog.
  callback | if this is non-null, the callback will receive a call to its modalStateFinished() when the box is dismissed with the index of the button that was clicked as its argument. The callback object will be owned and deleted by the system, so make sure that it works safely and doesn't keep any references to objects that might be deleted before it gets called.

See also
  MessageBoxOptions

References JUCE_CALLTYPE.

## showAsync() [2/2]

void JUCE_CALLTYPE juce::AlertWindow::showAsync | ( | const MessageBoxOptions & | options,
|  | std::function< void(int)> | callback )

static

Shows a dialog box using the specified options.

The box will be displayed and placed into a modal state, but this method will return immediately, and the callback will be invoked later when the user dismisses the box.

Parameters

  options | the options to use when creating the dialog.
  callback | if this is non-null, the callback will be called when the box is dismissed with the index of the button that was clicked as its argument.

See also
  MessageBoxOptions

References JUCE_CALLTYPE.

## showMessageBoxAsync()

void JUCE_CALLTYPE juce::AlertWindow::showMessageBoxAsync | ( | MessageBoxIconType | iconType,
|  | const String & | title,
|  | const String & | message,
|  | const String & | buttonText = String(),
|  | Component * | associatedComponent = nullptr,
|  | ModalComponentManager::Callback * | callback = nullptr )

static

Shows a dialog box that just has a message and a single button to get rid of it.

The box will be displayed and placed into a modal state, but this method will return immediately, and if a callback was supplied, it will be invoked later when the user dismisses the box.

Parameters

  iconType | the type of icon to show
  title | the headline to show at the top of the box
  message | a longer, more descriptive message to show underneath the headline
  buttonText | the text to show in the button - if this string is empty, the default string "OK" (or a localised version) will be used.
  associatedComponent | if this is non-null, it specifies the component that the alert window should be associated with. Depending on the look and feel, this might be used for positioning of the alert window.
  callback | if this is non-null, the callback will receive a call to its modalStateFinished() when the box is dismissed. The callback object will be owned and deleted by the system, so make sure that it works safely and doesn't keep any references to objects that might be deleted before it gets called.

References JUCE_CALLTYPE.

## showOkCancelBox()

bool JUCE_CALLTYPE juce::AlertWindow::showOkCancelBox | ( | MessageBoxIconType | iconType,
|  | const String & | title,
|  | const String & | message,
|  | const String & | button1Text = String(),
|  | const String & | button2Text = String(),
|  | Component * | associatedComponent = nullptr,
|  | ModalComponentManager::Callback * | callback = nullptr )

static

Shows a dialog box with two buttons.

Ideal for ok/cancel or yes/no choices. The return key can also be used to trigger the first button, and the escape key for the second button.

If JUCE_MODAL_LOOPS_PERMITTED is not defined or the callback parameter is non-null, this function will return immediately. The object passed as the callback argument will receive the result of the alert window asynchronously. Otherwise, if JUCE_MODAL_LOOPS_PERMITTED is defined and the callback parameter is null, the box is shown modally, and the method will block until the user has clicked the button (or pressed the escape or return keys). This mode of operation can cause problems, especially in plugins, so it is not recommended.

Parameters

  iconType | the type of icon to show
  title | the headline to show at the top of the box
  message | a longer, more descriptive message to show underneath the headline
  button1Text | the text to show in the first button - if this string is empty, the default string "OK" (or a localised version of it) will be used.
  button2Text | the text to show in the second button - if this string is empty, the default string "cancel" (or a localised version of it) will be used.
  associatedComponent | if this is non-null, it specifies the component that the alert window should be associated with. Depending on the look and feel, this might be used for positioning of the alert window.

  callback

  if this is non-null, the menu will be launched asynchronously, returning immediately, and the callback will receive a call to its modalStateFinished() when the box is dismissed, with its parameter being 1 if the ok button was pressed, or 0 for cancel. The callback object will be owned and deleted by the system, so make sure that it works safely and doesn't keep any references to objects that might be deleted before it gets called.

Returns
  true if button 1 was clicked, false if it was button 2. If the callback parameter is not null, the method always returns false, and the user's choice is delivered later by the callback.

References JUCE_CALLTYPE.

## showYesNoCancelBox()

int JUCE_CALLTYPE juce::AlertWindow::showYesNoCancelBox | ( | MessageBoxIconType | iconType,
|  | const String & | title,
|  | const String & | message,
|  | const String & | button1Text = String(),
|  | const String & | button2Text = String(),
|  | const String & | button3Text = String(),
|  | Component * | associatedComponent = nullptr,
|  | ModalComponentManager::Callback * | callback = nullptr )

static

Shows a dialog box with three buttons.

Ideal for yes/no/cancel boxes.

The escape key can be used to trigger the third button.

If JUCE_MODAL_LOOPS_PERMITTED is not defined or the callback parameter is non-null, this function will return immediately. The object passed as the callback argument will receive the result of the alert window asynchronously. Otherwise, if JUCE_MODAL_LOOPS_PERMITTED is defined and the callback parameter is null, the box is shown modally, and the method will block until the user has clicked the button (or pressed the escape or return keys). This mode of operation can cause problems, especially in plugins, so it is not recommended.

Parameters

  iconType | the type of icon to show
  title | the headline to show at the top of the box
  message | a longer, more descriptive message to show underneath the headline
  button1Text | the text to show in the first button - if an empty string, then "yes" will be used (or a localised version of it)
  button2Text | the text to show in the first button - if an empty string, then "no" will be used (or a localised version of it)
  button3Text | the text to show in the first button - if an empty string, then "cancel" will be used (or a localised version of it)
  associatedComponent | if this is non-null, it specifies the component that the alert window should be associated with. Depending on the look and feel, this might be used for positioning of the alert window.

  callback

  if this is non-null, the menu will be launched asynchronously, returning immediately, and the callback will receive a call to its modalStateFinished() when the box is dismissed, with its parameter being 1 if the "yes" button was pressed, 2 for the "no" button, or 0 if it was cancelled. The callback object will be owned and deleted by the system, so make sure that it works safely and doesn't keep any references to objects that might be deleted before it gets called.

Returns
  If the callback parameter has been set, this returns 0. Otherwise, it returns one of the following values:
  - 0 if the third button was pressed (normally used for 'cancel')
  - 1 if the first button was pressed (normally used for 'yes')
  - 2 if the middle button was pressed (normally used for 'no')

References JUCE_CALLTYPE.

## showScopedAsync()

ScopedMessageBox juce::AlertWindow::showScopedAsync | ( | const MessageBoxOptions & | options,
|  | std::function< void(int)> | callback )

static nodiscard

Shows an alert window using the specified options.

The box will be displayed and placed into a modal state, but this method will return immediately, and the callback will be invoked later when the user dismisses the box.

This function is always asynchronous, even if the callback is null.

The result codes returned by the alert window are as follows.

- One button:
  - button[0] returns 0
- Two buttons:
  - button[0] returns 1
  - button[1] returns 0
- Three buttons:
  - button[0] returns 1
  - button[1] returns 2
  - button[2] returns 0

Parameters

  options | the options to use when creating the dialog.
  callback | if this is non-null, the callback will receive a call to its modalStateFinished() when the box is dismissed with the index of the button that was clicked as its argument. The callback object will be owned and deleted by the system, so make sure that it works safely and doesn't keep any references to objects that might be deleted before it gets called.

Returns
  a ScopedMessageBox instance. The message box will remain visible for no longer than the ScopedMessageBox remains alive.

See also
  MessageBoxOptions

References JUCE_CALLTYPE.

Referenced by juce::StandalonePluginHolder::askUserToLoadState(), and juce::StandalonePluginHolder::askUserToSaveState().

## createAccessibilityHandler()

std::unique_ptr< AccessibilityHandler > juce::AlertWindow::createAccessibilityHandler | ( |  | ) |

override virtual

Override this method to return a custom AccessibilityHandler for this component.

The default implementation creates and returns a AccessibilityHandler object with an unspecified role, meaning that it will be visible to accessibility clients but without a specific role, action callbacks or interfaces. To control how accessibility clients see and interact with your component subclass AccessibilityHandler, implement the desired behaviours, and return an instance of it from this method in your component subclass.

The accessibility handler you return here is guaranteed to be destroyed before its Component, so it's safe to store and use a reference back to the Component inside the AccessibilityHandler if necessary.

This function should rarely be called directly. If you need to query a component's accessibility handler, it's normally better to call getAccessibilityHandler(). The exception to this rule is derived implementations of createAccessibilityHandler(), which may find it useful to call the base class implementation, and then wrap or modify the result.

See also
  getAccessibilityHandler

Reimplemented from juce::Component.

## paint()

void juce::AlertWindow::paint | ( | Graphics & | g | ) |

override protected virtual

Components can override this method to draw their content.

The paint() method gets called when a region of a component needs redrawing, either because the component's repaint() method has been called, or because something has happened on the screen that means a section of a window needs to be redrawn.

Any child components will draw themselves over whatever this method draws. If you need to paint over the top of your child components, you can also implement the paintOverChildren() method to do this.

If you want to cause a component to redraw itself, this is done asynchronously - calling the repaint() method marks a region of the component as "dirty", and the paint() method will automatically be called sometime later, by the message thread, to paint any bits that need refreshing. In JUCE (and almost all modern UI frameworks), you never redraw something synchronously.

You should never need to call this method directly - to take a snapshot of the component you could use createComponentSnapshot() or paintEntireComponent().

Parameters

  g | the graphics context that must be used to do the drawing operations.

See also
  repaint, paintOverChildren, Graphics

Reimplemented from juce::Component.

## mouseDown()

void juce::AlertWindow::mouseDown | ( | const MouseEvent & | event | ) |

override protected virtual

Called when a mouse button is pressed.

The MouseEvent object passed in contains lots of methods for finding out which button was pressed, as well as which modifier keys (e.g. shift, ctrl) were held down at the time.

Once a button is held down, the mouseDrag method will be called when the mouse moves, until the button is released.

Parameters

  event | details about the position and status of the mouse event, including the source component in which it occurred

See also
  mouseUp, mouseDrag, mouseDoubleClick, contains

Reimplemented from juce::MouseListener.

## mouseDrag()

void juce::AlertWindow::mouseDrag | ( | const MouseEvent & | event | ) |

override protected virtual

Called when the mouse is moved while a button is held down.

When a mouse button is pressed inside a component, that component receives mouseDrag callbacks each time the mouse moves, even if the mouse strays outside the component's bounds.

Parameters

  event | details about the position and status of the mouse event, including the source component in which it occurred

See also
  mouseDown, mouseUp, mouseMove, contains, setDragRepeatInterval

Reimplemented from juce::MouseListener.

## keyPressed()

bool juce::AlertWindow::keyPressed | ( | const KeyPress & | key | ) |

override protected virtual

Called when a key is pressed.

When a key is pressed, the component that has the keyboard focus will have this method called. Remember that a component will only be given the focus if its setWantsKeyboardFocus() method has been used to enable this.

If your implementation returns true, the event will be consumed and not passed on to any other listeners. If it returns false, the key will be passed to any KeyListeners that have been registered with this component. As soon as one of these returns true, the process will stop, but if they all return false, the event will be passed upwards to this component's parent, and so on.

The default implementation of this method does nothing and returns false.

See also
  keyStateChanged, getCurrentlyFocusedComponent, addKeyListener

Reimplemented from juce::Component.

## lookAndFeelChanged()

void juce::AlertWindow::lookAndFeelChanged | ( |  | ) |

override protected virtual

Called to let the component react to a change in the look-and-feel setting.

When the look-and-feel is changed for a component, this method, repaint(), and colourChanged() are called on the original component and all its children recursively.

It can also be triggered manually by the sendLookAndFeelChange() method, in case an application uses a LookAndFeel class that might have changed internally.

See also
  sendLookAndFeelChange, getLookAndFeel

Reimplemented from juce::Component.

## userTriedToCloseWindow()

void juce::AlertWindow::userTriedToCloseWindow | ( |  | ) |

override protected virtual

For components on the desktop, this is called if the system wants to close the window.

This is a signal that either the user or the system wants the window to close. The default implementation of this method will trigger an assertion to warn you that your component should do something about it, but you can override this to ignore the event if you want.

Reimplemented from juce::Component.

## getDesktopWindowStyleFlags()

int juce::AlertWindow::getDesktopWindowStyleFlags | ( |  | ) | const

override protected virtual

Reimplemented from juce::TopLevelWindow.

## getDesktopScaleFactor()

float juce::AlertWindow::getDesktopScaleFactor | ( |  | ) | const

inline override protected virtual

Returns the default scale factor to use for this component when it is placed on the desktop.

The default implementation of this method just returns the value from Desktop::getGlobalScaleFactor(), but it can be overridden if a particular component has different requirements. The method only used if this component is added to the desktop - it has no effect for child components.

Reimplemented from juce::Component.

References juce::Desktop::getInstance().

## Member Data Documentation

## NoIcon

auto juce::AlertWindow::NoIcon = MessageBoxIconType::NoIcon

static constexpr

## QuestionIcon

auto juce::AlertWindow::QuestionIcon = MessageBoxIconType::QuestionIcon

static constexpr

## WarningIcon

auto juce::AlertWindow::WarningIcon = MessageBoxIconType::WarningIcon

static constexpr

Referenced by juce::StandalonePluginHolder::askUserToLoadState(), and juce::StandalonePluginHolder::askUserToSaveState().

## InfoIcon

auto juce::AlertWindow::InfoIcon = MessageBoxIconType::InfoIcon

static constexpr

### Purchase

Get JUCE

### Discover

What's New in JUCE Features

### Learn

Documentaion Tutorials Made with JUCE Resources

### Support

JUCE Forum Newsletter Archive

### About

Contact Us JUCE Legal JUCE Licensing FAQ

### Events

Audio Developer Conference
© Raw Material Software Limited